/*$Id*/

#include <stdio.h>
#include <stdlib.h>
#include <sys/times.h>
#include <time.h>
#include "mergesort.h"

/***************************************************************************/ 
/*programa para mostrar el algoritmo mergesort con una lista enlazada	   */
/*Autor: mundacho							   */
/*Email: mundacho@bigfoot.com						   */
/*Descripcin: Se le da una entrada de nmeros separados por nuevas lneas */
/*		e imprime la entrada ordenada				   */
/***************************************************************************/ 

int numcomp(NODO *, NODO *);

int main(void)
{
	NODO *p, *q, *r;
	int valor;
	clock_t comienzo; /*vamos a medir cuanto tardo en ordenar el archivo*/
	clock_t final;
	struct tms tiempos;
	p = q = r = NULL;
	while (scanf("%d", &valor) != EOF){ /*esto lee la entrada hasta el fin*/
					/*del archivo y la guarda en la lista*/
		if (q == NULL)		/*enlazada apuntada por q*/
			q = p = (NODO *)malloc(sizeof(NODO));
		else {
			p->sig = (NODO *)malloc(sizeof(NODO));
			p = p->sig;
		}
		p->valor = valor;
	}
	if (q == NULL) { /*No hubo entrada :'(*/
		return 0;
	}
	p->sig = NULL;/*acabamos la lista*/
	comienzo = times (&tiempos); /*los valores almacenados en tiempos no*/
					/*los usaremos*/
	p = q = r = mergesort(q,(int (*)(void*,void*))numcomp);
	final = times (&tiempos);
	/*Mostramos la entrada ordenada*/
	while (r != NULL){
		printf("%d\n", r->valor);
		r = r->sig;
	}
	/*Imprimimos cuanto tardamos en ordenar la entrada*/
	printf ("Se tardaron %f segundos en ordenar el archivo\n", (float) (final - comienzo) / CLOCKS_PER_SEC);
	/*Liberamos la memoria*/
	while (p != NULL){
		r = p;
		p = p->sig;
		free(r);
	}
	return 0;
}
int numcomp(NODO *p, NODO *q)/*funcin que compara los dos enteros de la lista*/
{			/*puede ser modificada para cualquier comparacin*/
	if (p->valor < q->valor)
		return -1;
	return 0;
}
