/*$Id$*/

#include "mergesort.h"
#include <stdio.h>

NODO *mergesort(NODO *lista, int (*comp)(void*,void*))
{
	NODO *u, *r, *s;
	u = r = NULL; /*apntadores a las sublistas*/
	if (lista->sig == NULL) /*si la lista es solo un elemento est ordenada*/
		return lista;
	u = split(lista);
	r = mergesort(lista, (int (*)(void*,void*)) comp);
	s = mergesort(u, (int (*)(void*,void*)) comp);
	return merge(r, s, (int (*)(void*,void*)) comp);
}

NODO *split (NODO *lista)
{
	NODO *p, *q;
	if (lista == NULL)
		return lista;
	p = q = lista->sig;
	while (q != NULL){
		lista->sig = q->sig;
		lista = lista->sig;
		if (lista == NULL){
			q->sig = NULL;
			break;
		}
		q->sig = lista->sig;
		q = q->sig;
	}
	if (q == NULL)
		lista->sig = NULL;
	return p;
}

NODO *merge(NODO *lista1, NODO *lista2, int (*comp)(void*,void*))
{
	NODO *p, *q, *r, *s;
	if ((*comp)(lista1, lista2) < 0){
		r = p = s = lista1;
		q = lista2;
	}
	else {
		r = p = s = lista2;
		q = lista1;
	}
	p = r->sig;
	while (p != NULL && q != NULL){
		if ((*comp)(q, p) < 0){
			s->sig = q;
			q = q->sig;
		}
		else {
			s->sig = p;
			p = p->sig;
		}
	s = s->sig;
	}
	if (p == NULL)
		s->sig = q;
	else
		s->sig = p;
	return r;
}
